<?php
$m = 'Vpn';
$berogui_path = '/usr/local/www/berogui';

/* [REQUIRED] */
require_once('/usr/fallback/beroConf.php');
require_once("$berogui_path/misc/database.php");
require_once("$berogui_path/includes/Helper/Helper.php");
require_once("$berogui_path/includes/beronode/VpnApi.php");

/* [INTERN FUNCTIONS] */
function exitInvalidData($m, $invalid) {
	echo "<script>window.location='../../index.php?m=$m&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

function exitOnError($m, $error) {
	echo "<script>window.location='../../index.php?m=$m&error=2&reason={$error['error']}'</script>";
	exit(1);
}

function isDataAccepted($m, &$data, $exec_ajax = 1, $invalid = []) {
	$parameters = require("$berogui_path/modules/Vpn/vpn_parameters.php");
	Helper::setDataValidator($parameters['server'], $list_data, $options_data);
	$data = Helper::sanitizePost($data, $list_data, $exec_ajax, $invalid, $options_data);
	if (!$exec_ajax) {
		exitInvalidData($m, $invalid);
	}
}

/* [CHECKING SESSION] */
$newTarget = "/app/berogui/index.php?m=$m";
include("$berogui_path/includes/session.php");
unset($newTarget);

/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST['submit']);
$exec_ajax = 1;

$data = $_POST['data'];
unset($data);

$list_post = [
	'action'				=> 'select',
	'idkey' 				=> 'int>=0',
	'isMainVpnExist'=> 'bool',
];

$options_post = [
	'action' => ['delete', 'kill-client', 'save'],
];

$_POST = Helper::sanitizePost($_POST, $list_post, $exec_ajax, $invalid, $options_post);
$action = $_POST['action'];

/* [EXECUTING AJAX] */
if (!$exec_ajax) {
	exitInvalidData($m, $invalid);
}

$vpn_api = new VpnApi();

switch ($action) {
case 'delete':
	$id = $_POST['idkey'];

	// remove vpn server
	$ret = json_decode($vpn_api->serverStop($id), true);
	if (isset($ret['error'])) {
		exitOnError($m, $ret);
	}

	// update beroari
	$ba = new beroAri();
	$ba->delete("DELETE FROM sbc_vpns WHERE id='$id'");

	// update beroconf
	$bc = new beroConf('root');
	$update = [
		'is-vpn-running'	=> 0,
		'lan-ipaddr' 			=> '',
		'lan-netmask'			=> '',
		'lan-mode'				=> 'single',
	];
	foreach ($update as $key => $value) {
		$bc->set('root', $key, $value);
	}
	break;
case 'kill-client':
	// get client info
	require_once("$berogui_path/modules/Vpn/vpn_helper.php");
	$client = VpnHelper::getDataClients();
	$ret = json_decode($vpn_api->clientKill(0, ['name' => $client['commonName']]), true);
	if (isset($ret['error'])) {
		exitOnError($m, $ret);
	}
	break;
case 'save':
	isDataAccepted($m, $data);
	$id = $_POST['idkey'];
	$hasMainVpn = $_POST['isMainVpnExist'] == 1;

	// update beroari -> must be executed before vpn_api since the setup_script use beroAri database
	$ba = new beroAri();
	if ($hasMainVpn) {
		$ba->updateTable('sbc_vpns', $id, $data);
	}
	else {
		$ba->insertTable('sbc_vpns', $id, $data);
	}

	// update VPN settings using nodejs server
	$ret = json_decode($vpn_api->serverStart($id, $data), true);
	if (isset($ret['error'])) {
		exitOnError($m, $ret);
	}

	$ipaddr = Helper::getNetworkIpAddr('tun0', 1);
	$ba->updateTable('sbc_vpns', $id, ['ipaddr' => $ipaddr]);

	// update beroconf
	$bc = new beroConf('root');
	$update = [
		'is-vpn-running'	=> 1,
		'lan-ipaddr' 			=> $ipaddr,
		'lan-netmask'			=> Helper::getNetworkMask('tun0', 1),
		'lan-mode'				=> 'lan-wan',
	];
	foreach ($update as $key => $value) {
		$bc->set('root', $key, $value);
	}
	break;
}

// redirect
echo Helper::redirectAfterSubmit($ba, $m);
exit(0);
?>
